<template>
  <div>
    <q-form>
    <q-input
        v-show="tab === 'new'"
        dense
        class="q-ma-sm"
        v-model="form.name"
        label="Name *"
        lazy-rules
        :rules="[ val => val && val.length > 0 || 'Ingresa tu Nombre']"
        >
        <template v-slot:prepend>
            <q-icon name="report"></q-icon>
        </template>
    </q-input>

        <q-input
        dense
        class="q-ma-sm"
        type="email"
        v-model="form.email"
        label="Email *"
        lazy-rules
        :rules="[ val => val && val.length > 0 || 'Ingresa tu Email']"
        >
        <template v-slot:prepend>
            <q-icon name="mail"></q-icon>
        </template>
        </q-input>

        <q-input
        dense
        class="q-ma-sm"
        :type="isPwd ? 'password' : 'text'"
        v-model="form.password"
        label="ContraseÃ±a *"
        lazy-rules
        :rules="[
             val => val && val.length > 0 || 'Ingresa tu contraseÃ±a',
        ]"
        >
        <template v-slot:prepend>
            <q-icon name="vpn_key"></q-icon>
        </template>
        <template v-slot:append>
            <q-icon
            :name="isPwd ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            @click="isPwd = !isPwd"
            />
        </template>
        </q-input>
        <div class="text-center q-ma-sm">
        <q-btn
             dense
            color="teal-14"
            class="full-width q-mr-sm text-black shadow-1"
            icon="ion-return-right"
            :loading="loading"
            type="submit"
            :label="tab === 'new'? 'Nuevo': 'Ingresar'"
            @click="onSubmit"
        >
             <template v-slot:loading>
             <q-spinner-hourglass class="on-left" />
              Cargando...
             </template>
         </q-btn>
        </div>
    </q-form>
  </div>
</template>
<script>
import { mapMutations } from 'vuex'
export default {
  created () {
    this.$q.dark.set(false)
  },
  props: ['tab'],
  data () {
    return {
      splinter: 23,
      form: {},
      isPwd: true,
      loading: false
    }
  },
  methods: {
    ...mapMutations('generals', ['login']),
    onSubmit () {
      if (this.tab === 'new') {
        console.log(this.form)
        this.loading = true
        this.$api.post('create', this.form).then(res => {
          if (res) { // Se debe ejecutar una mutacion que modifique el state con sessionInfo
            this.login(res)
            this.$router.push('menu')
          }
          this.loading = false
        })
      } else if (this.tab === 'begin') {
        delete this.form.name
        this.loading = true
        this.$api.post('login', this.form).then(res => {
          if (res) { // Se debe ejecutar una mutacion que modifique el state con sessionInfo
            this.login(res)
            this.$router.push('menu')
          }
          this.loading = false
        })
      }
    }
  }
}
</script>
